C*******************************************************************
C* Copyright (C) 2003 University at Buffalo
C*
C* This software can be redistributed free of charge.  See COPYING
C* file in the top distribution directory for more details.
C*
C* This software is distributed in the hope that it will be useful,
C* but WITHOUT ANY WARRANTY; without even the implied warranty of
C* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
C*
C* Author: 
C* Description: 
C*
C*******************************************************************
C* $Id: getcoef.f 128 2007-06-07 19:51:52Z dkumar $ 
C*

C***********************************************************************
      subroutine gmfggetcoef(Uvec, dUdx, dUdy, dx, bedfrictang,
     1     intfrictang, Kactx, Kacty, tiny, gravity, slope, g_scale,
     1     epsilon)
C***********************************************************************
        
      include 'rnr.h'
      double precision omega
      parameter (omega=1.0d0)
      double precision dUdx(3), dUdy(3), Uvec(3), coefABCD(4), dx(2)
      double precision Kactx, Kacty, zeta, epsilonx, tiny
      double precision vel,cosphi,tandel,w,sgn,ka, epsilon
      
      double precision bedfrictang,intfrictang, tttest
      double precision gravity(3),slope(2),g_scale,mom,cosx,cosy,dh,db
      integer i,j
c     vel is used to determine if velocity gradients are converging or diverging
      external sgn
      
c     COEFFICIENTS
      cosphi=dcos(intfrictang)
      tandel=dtan(bedfrictang)
      if(uvec(1) .gt. tiny) then
c         tttest = sgn(vel, tiny)
         vel=(dUdx(2)/uvec(1) - uvec(2)*dudx(1)/uvec(1)**2+
     1        dUdy(3)/uvec(1) - uvec(3)*dudy(1)/uvec(1)**2)
         Kactx=(2.d0/cosphi**2)*(1.d0-sgn(vel,tiny)*
     1        dsqrt(dabs(1.d0-(1.d0+tandel**2)*cosphi**2) )) -1.d0
         if(sgn(vel,tiny).eq.0.0) kactx = 1.d0
         Kacty=Kactx

c     if there is no yielding...
         if(dabs(uvec(2)/uvec(1)) .lt. tiny .and.
     1        dabs(uvec(3)/uvec(1)) .lt. tiny) then
            kactx = 1.d0
            kacty = 1.d0
         endif
      else 
         kactx = 1.d0
         kacty = 1.d0
      endif
      
      kactx = epsilon * kactx
      kacty = epsilon * kacty

c     compute effective gravity in Z direction(Model A = formula of Yuan et al)
      if(uvec(1) .gt. tiny) then
         mom = slope(1)*slope(1)+slope(2)*slope(2)
         dh = slope(1)*dudx(1) + slope(2)*dudy(1)
         db = 1.0/(1.0d0+mom)
         w  = mom + 1.0d0
         cosx = uvec(2)*slope(1)+uvec(3)*slope(2)
         vel = dsqrt(uvec(2)*uvec(2)+uvec(3)*uvec(3)+cosx*cosx)/uvec(1)
         zeta = 1.0-dsqrt(w)*tandel*cosx/uvec(1)/max(vel,1.0d-14)
         ka = exp(-omega*vel)   !omega is empirical and can be changed for stability
         gravity(3) = 9.8*zeta*db/(1.0d0+ka*epsilon*dh *db)   !ka is factor for stability
      else
         gravity(3) = 9.8   !h<tiny are assumed fully quiscent
      endif
      gravity(1) =-gravity(3)*slope(1)
      gravity(2) =-gravity(3)*slope(2)
      do i=1,3
        gravity(i) = gravity(i)/g_scale
      enddo
      return
      end
