C*******************************************************************
C* Copyright (C) 2003 University at Buffalo
C*
C* This software can be redistributed free of charge.  See COPYING
C* file in the top distribution directory for more details.
C*
C* This software is distributed in the hope that it will be useful,
C* but WITHOUT ANY WARRANTY; without even the implied warranty of
C* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
C*
C* Author: 
C* Description: 
C*
C*******************************************************************
C* $Id: predict.f 143 2007-06-25 17:58:08Z dkumar $ 
C*

C***********************************************************************
      subroutine predict(Uvec,dUdx,dUdy,Uprev,tiny,kact,dt2, g, 
     1     curv, bedfrictang, intfrictang, beta, epsilon,
     2     dgdx, frict_tiny, order_flag, VxVyB, 
     3     IF_STOPPED,fluxsrc)
C***********************************************************************
c     this routine only calculates Uvec for a half step

***********************************************************************
******NOTE:  d(g(3)*Uvec(1))/dx is approximated by g(3)*dUvec(1)/dx !!!
***********************************************************************
      include 'rnr.h'
      integer order_flag, IF_STOPPED
      double precision dUdx(3),dUdy(3),kact(2),kactxy,Uvec(3)
      double precision tiny, epsilon, dt2, Uprev(3), dgdx(2)
c new curv(1)=b_xx, curv(2)=b_yy, curv(3)=b_xy
      double precision c_sq, h_inv, g(3),curv(3), beta(2)
      double precision intfrictang, bedfrictang, sgn, frict_tiny
      double precision sgn_dudy, sgn_dvdx, tmp
c      double precision dnorm
      double precision speed,unitvx,unitvy,VxVy(2),VxVyB(2),VxVyS(2)
      double precision forcegrav, forceintx, forceinty
      double precision forcebedmax, forcebedequil
      double precision forcebedx, forcebedy
      double precision tanbed,fluxsrc(3),cos2
      double precision xslope,yslope,deltab,be,forcebedequily,dnorm,tosh
      external sgn


c     curv := inverse of radius of curvature = second derivative of 
c     position normal to tangent with respect to distance along tangent,
c     if dz/dx=0 curve=d2z/dx2, otherwise rotate coordinate system so 
c     dz/dx=0, that is mathematical definition of curvature I believe
c     laercio returns d2z/dx2 whether or not dz/dx=0 in his GIS functions

c TEST********** order_flag = 1 
c     meaning of IF_STOPPED=0,1,2 is explained by stoppedflags in element2.h
c      write(*,*) "order_flag in predict=", order_flag 
      kactxy=0.5*(kact(1)+kact(2))
      xslope=beta(1)
      yslope=beta(2)
      deltab=dsqrt(xslope*xslope+yslope*yslope+1.0d0)
      cos2=1.0d0/(deltab*deltab)

      uprev(1) = uvec(1)
      uprev(2) = uvec(2)
      uprev(3) = uvec(3)
c     IF_STOPPED at this is determined by calc_stop_crit called by get_and_coef_eigen.C
      if(IF_STOPPED.eq.2) then
         VxVy(1)=0.0
         VxVy(2)=0.0
         VxVyS(1)=0.0
         VxVyS(2)=0.0
      else
         VxVy(1)=VxVyB(1)
c     uvec(2)/uvec(1)
         VxVy(2)=VxVyB(2)
c     uvec(3)/uvec(1)
         VxVyS(1)=VxVyB(1)
         VxVyS(2)=VxVyB(2)
      endif

      if (order_flag .eq. 2) then
         c_sq = kactxy*g(3)*Uvec(1)
c     h_inv := 1/Uvec(1)                         
         
c     dF/dU, dG/dU and S terms if Uvec(1) > TINY !
         if(Uprev(1) .gt. TINY) then
         Uvec(1)=Uvec(1) - dt2*(dUdx(2)+dUdy(3)+fluxsrc(1))
         Uvec(1)=dmax1(Uvec(1),0.d0)
         
            h_inv = 1.d0/Uprev(1)
            tanbed=dtan(bedfrictang)

c     here speed is speed squared
         speed=VxVy(1)**2+VxVy(2)**2+(VxVy(1)*xslope+VxVy(2)*yslope)**2
            if(speed.GT.0.0) then
c     here speed is speed
               speed=dsqrt(speed)
               unitvx=VxVy(1)/speed
               unitvy=VxVy(2)/speed
            else
               unitvx=0.0
               unitvy=0.0
            endif

c            dnorm=dsqrt(uprev(2)**2+uprev(3)**2+tiny**2)

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     ****** X-dir ******
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     dF/dU and dG/dU terms
            Uvec(2) = Uvec(2)- 
     1           dt2*((c_sq-VxVy(1)**2)*dUdx(1)+ 
     2           2.d0*VxVy(1)*dUdx(2)-
     3           VxVy(1)*VxVy(2)*dUdy(1)+
     4           VxVy(2)*dUdy(2)+ 
     5           VxVy(1)*dUdy(3)+
     6           fluxsrc(2)) 
            Uvec(3) = Uvec(3) - 
     1           dt2*((c_sq-VxVy(2)**2)*dUdy(1) +
     2           2.d0*VxVy(2)*dUdy(3) -
     3           VxVy(1)*VxVy(2)*dUdx(1)+
     4           VxVy(2)*dUdx(2)+
     5           VxVy(1)*dUdx(3)+
     6           fluxsrc(3)) 

c     x direction source terms

c     the gravity force in the x direction
            be=1.0/( 1.0-deltab*tanbed*(VxVy(1)*xslope+VxVy(2)*yslope)
     &         /max(speed,1.0d-14) )
            tmp=cos2
            dnorm = dmax1(be*g(3)+(VxVyS(1)*VxVyS(1)*curv(1)
     $                 +VxVyS(2)*VxVyS(2)*curv(2)+2.0*VxVyS(1)*VxVyS(2)
     $                 *curv(3))*tmp, 0.0d0)
            g(1)=-dnorm*xslope
            g(2)=-dnorm*yslope
            forcegrav=g(1)*Uprev(1)

c     the internal friction force
            tmp = h_inv*(dudy(2)-VxVyS(1)*dudy(1)
     &                  +dudx(3)-VxVyS(2)*dudx(1))
            sgn_dudy = -sgn(tmp, frict_tiny)
            sgn_dvdx = sgn_dudy
            forceintx=0.5*sgn_dudy*Uprev(1)*kactxy*(2.0*g(3)*dUdy(1)
     $           +dgdx(2)*Uprev(1))*dsin(intfrictang) 
            
c     the bed friction force for fast moving flow
            tosh = dnorm*Uprev(1)*deltab*tanbed
            forcebedx = unitvx *tosh

c     maximum friction force the bed friction can support
         forcebedmax=be*g(3)*Uprev(1)*tanbed
c     check whether a moving pile will stop; replace 'stoppedflags' got at calc_stop_crit
      if(speed.gt.1.0d-14) then  !small number is to exclude randomly small speed below machine zero
         IF_STOPPED=0
         dnorm=dsqrt((Uvec(2)+forcegrav*dt2)**2
     %              +(Uvec(3)+g(2)*Uprev(1)*dt2)**2
     %              +((Uvec(2)+forcegrav*dt2)*xslope
     %               +(Uvec(3)+g(2)*Uprev(1)*dt2)*yslope)**2)
c     if the admissible 'stress' is less than the maximum stress, the pile might stop
         if(dnorm.lt.forcebedmax*dt2) then
            tmp=dsqrt((xslope+epsilon*dUdx(1))**2
     $               +(yslope+epsilon*dUdy(1))**2)
c     if tan(internal friction angle) > free surface's gradient, the pile must stop
            if(dtan(intfrictang).gt.tmp) IF_STOPPED=2
         end if
      else
         IF_STOPPED=1
         tmp=dsqrt((xslope+epsilon*dUdx(1))**2
     $            +(yslope+epsilon*dUdy(1))**2)
c     if tan (internal friction angle) > free surface's gradient, the pile remains v=0
         if(dtan(intfrictang).gt.tmp) IF_STOPPED=2
      end if
c     the bed friction force for stopped or nearly stopped flow

c     the static friction force is LESS THAN or equal to the friction
c     coefficient times the normal force but it can NEVER exceed the 
c     NET force it is opposing

      if(IF_STOPPED.eq.2) then
c     the static friction force only serves to oppose other terms so that U(2)=0
         forcebedx=forcegrav-forceintx
         Uvec(2)=0.0
      else if(IF_STOPPED.eq.1) then
c     the NET force the bed friction force is opposing at V=0;
c     the static friction force equals the Coulomb threshold but against the net force direction
         forcebedequil=g(1)*Uprev(1)-epsilon*g(3)*Uprev(1)*dUdx(1)
         forcebedequily=g(2)*Uprev(1)-epsilon*g(3)*Uprev(1)*dUdy(1)
         dnorm=dsqrt(forcebedequil**2+forcebedequily**2
     $               +(forcebedequil*xslope+forcebedequily*yslope)**2)
         forcebedx=deltab*forcebedmax* forcebedequil/dnorm
      endif
c     the "correct" stopped or nearly stopped flow bed friction force
c     (this force is not entirely "correct" it will leave a "negligible"
c     (determined by stopping criteria) amount of momentum in the cell)

c     all the x source terms
            Uvec(2) = Uvec(2) + dt2*(forcegrav -forceintx -forcebedx)
            if(IF_STOPPED.eq.2) Uvec(2) = 0.0d0
c            write(*,*) 'int', forceintx, 'bed', forcebedx

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     ****** Y-dir ******
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     the gravity force in the y direction
            forcegrav=g(2)*Uprev(1)

c     the internal friction force
            forceinty=0.5*sgn_dvdx*Uprev(1)*kactxy*(2.0*g(3)*
     $           dudx(1)+dgdx(1)*Uprev(1))*dsin(intfrictang)

c     the bed friction force for fast moving flow
               forcebedy = unitvy *tosh

c     the bed friction force for stopped or nearly stopped flow

      if(IF_STOPPED.eq.2) then
c     the static friction force only serves to oppose other terms so that U(3)=0
         forcebedy=forcegrav-forceinty
         Uvec(3)=0.0
      else if(IF_STOPPED.eq.1) then
c     the static friction force equals the Coulomb threshold but against the net force direction
         forcebedy=deltab*forcebedmax* forcebedequily/dnorm
      endif

c     all the y source terms
            Uvec(3) = Uvec(3) + dt2*(forcegrav -forceinty -forcebedy)
            if(IF_STOPPED.eq.2) Uvec(3) = 0.0d0

         endif
      endif
c     below correction makes velocity at front smaller (but set h=0 makes velocity largest)
      if(Uvec(1).lt.tiny) then
         Uvec(2)=0.0
         Uvec(3)=0.0
      end if
      return
      end
